#include <Arduino.h>
#include "max80_gpio.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
static const char TAG[] = __FILE__;
extern portMUX_TYPE sync_isr;
extern TaskHandle_t ledtask;
volatile bool led1=false;
volatile bool led2=false;
volatile bool led3=false;
void IRAM_ATTR ISR_MOSI() {
    led1=!led1;
    digitalWrite(MAX80_LED1,led1);
}
void IRAM_ATTR ISR_CS() {
    led2=!led2;
    digitalWrite(MAX80_LED2,led2);

}
void IRAM_ATTR ISR_CLK() {
    led3=!led3;
    digitalWrite(MAX80_LED3,led3);
}
void blink_led(void *pvParameter)
{
    uint32_t receivedValue=0;
    uint16_t led1_freq=0;
    uint16_t led2_freq=0;
    uint16_t led3_freq=0;
    long led1Millis=0;
    long led2Millis=0;
    long led3Millis=0;
    while(1) {
        unsigned long currentMillis = millis();
        if (currentMillis - led1Millis >=led1_freq && !(led1_freq==0 || led1_freq==1)) {
            led1=!led1;
            digitalWrite(MAX80_LED1,led1);  
            led1Millis = currentMillis;
        }else if(led1_freq==0 && led1){
            digitalWrite(MAX80_LED1,false);
        }else if(led1_freq==1 && !led1){
            digitalWrite(MAX80_LED1,true);
        }
        if (currentMillis - led1Millis >=led2_freq && !(led2_freq==0 || led2_freq==1)) {
            led2=!led2;
            digitalWrite(MAX80_LED2,led2);  
            led2Millis = currentMillis;
        }else if(led2_freq==0 && led2){
            digitalWrite(MAX80_LED2,false);
        }else if(led2_freq==1 && !led2){
            digitalWrite(MAX80_LED2,true);
        }
        if (xTaskNotifyWait(0, ULONG_MAX, &receivedValue, 10) == pdPASS) {     

            if (receivedValue & 1){
                led1_freq=(uint16_t)receivedValue >> 8;
            }
            if (receivedValue & 2){
                led2_freq=(uint16_t)receivedValue >> 8;
            }
            if (receivedValue & 3){
                led3_freq=(uint16_t)receivedValue >> 8;
            }
        }
        vTaskDelay(10/portTICK_PERIOD_MS);
    }
}
namespace max80 {
    
	void gpio::init(){
        pinMode(MAX80_LED1,OUTPUT);
        pinMode(MAX80_LED2,OUTPUT);
        pinMode(MAX80_LED3,OUTPUT);
        // Just for test
        pinMode(MAX80_FPGA_MOSI,INPUT);
        pinMode(MAX80_FPGA_CS,INPUT);
        pinMode(MAX80_FPGA_CLK,INPUT);
        pinMode(MAX80_FPGA_MISO,INPUT);
        pinMode(MAX80_RTC_32KHZ ,INPUT);
        pinMode(MAX80_FPGA_I2C_SDA,INPUT);
        pinMode(MAX80_FPGA_I2C_SCL,INPUT);
          
        pinMode(MAX80_FPGA_TDI, INPUT);
        pinMode(MAX80_FPGA_TDO, INPUT);
        pinMode(MAX80_FPGA_TCK, INPUT);
        pinMode(MAX80_FPGA_TMS, INPUT);
        
        pinMode(MAX80_FPGA_TDI, INPUT);
        pinMode(MAX80_FPGA_TDO, INPUT);
        pinMode(MAX80_FPGA_TCK, INPUT);
        pinMode(MAX80_FPGA_TMS, INPUT);
        //attachInterrupt(MAX80_FPGA_MISO, ISR_MOSI, CHANGE);
        attachInterrupt(MAX80_FPGA_CS, ISR_CS, CHANGE);
        attachInterrupt(MAX80_FPGA_CLK, ISR_CLK, CHANGE);

    }

    
}
